--*********************************************************************************
--* This file is part of the RIBit Renderman(tm) exporter for max
--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes
--*********************************************************************************

plugin modifier mo_RIBit_Particles
	name:"RIBit Particles"
	category:"RIBit"
	classID:#(0x8b94596f, 0xd2e0bc06)
	version:1
(

	parameters RIBit_Attributes rollout:ro_RIBit_Attributes
	(
		Type			type:#integer ui:rbType default:1 animatable:false
		ColorPP			type:#string ui:edColorPP default:""
		OpacityPP 		type:#string ui:edOpacityPP default:""
		SizePP	 		type:#string ui:edSizePP default:""
		RIBboxPP 		type:#string ui:edRIBBoxPP default:""
		spriteTwistPP	type:#string ui:edSpriteTwistPP default:""
		instanceOrientPP type:#string ui:edInstanceOrientPP default:""
	)


	rollout ro_RIBit_Attributes "RIBit Particle Attributes"
	(
		local editBoxMode = #none

		rollout ro_RIBit_params_edit "Edit Particle Parameters"
		(
			local editBoxMode = #none

			editText edRIBCode "" width:400 height:200 pos:[5,5] text:""
			button bnClear "Clear" width:60 height:16 offset:[-150,0]
			button bnCancel "Cancel" width:60 height:16 pos:(bnClear.pos + [230,0])
			button bnOK "OK" width:60 height:16 pos:(bnCancel.pos + [75,0])

			on bnClear pressed do (
				edRIBCode.text = ""
			)

			on ro_RIBit_params_edit open do (
				editBoxMode = ro_RIBit_Attributes.editBoxMode
				case editBoxMode of (
					#colorPP: 		edRIBCode.text = ro_RIBit_Attributes.edColorPP.text
					#opacityPP: 	edRIBCode.text = ro_RIBit_Attributes.edOpacityPP.text
					#sizePP: 		edRIBCode.text = ro_RIBit_Attributes.edSizePP.text
					#ribBoxPP: 		edRIBCode.text = ro_RIBit_Attributes.edRIBBoxPP.text
					#spriteTwistPP: edRIBCode.text = ro_RIBit_Attributes.edSpriteTwistPP.text
					#instanceOrientPP: 	edRIBCode.text = ro_RIBit_Attributes.edInstanceOrientPP.text
				)
			)

			on ro_RIBit_params_edit close do (
				local lines = filterString edRIBCode.text "\n\r"
				local str = ""
				if lines.count > 0 then (
					str = lines[1]
					for i = 2 to lines.count do
						str += "\n" + lines[i]
				)
				case editBoxMode of (
					#colorPP: 		ro_RIBit_Attributes.edColorPP.text = str
					#opacityPP: 	ro_RIBit_Attributes.edOpacityPP.text = str
					#sizePP: 		ro_RIBit_Attributes.edSizePP.text = str
					#ribBoxPP: 		ro_RIBit_Attributes.edRIBBoxPP.text = str
					#spriteTwistPP: ro_RIBit_Attributes.edSpriteTwistPP.text = str
					#instanceOrientPP: 	ro_RIBit_Attributes.edInstanceOrientPP.text = str
				)
				ro_RIBit_Attributes.editBoxMode = #none
				ro_RIBit_Attributes.updateButtons #none
			)

			on bnCancel pressed do (
				case editBoxMode of (
					#colorPP: 		edRIBCode.text = ro_RIBit_Attributes.edColorPP.text
					#opacityPP: 	edRIBCode.text = ro_RIBit_Attributes.edOpacityPP.text
					#sizePP: 		edRIBCode.text = ro_RIBit_Attributes.edSizePP.text
					#ribBoxPP: 		edRIBCode.text = ro_RIBit_Attributes.edRIBBoxPP.text
					#spriteTwistPP: edRIBCode.text = ro_RIBit_Attributes.edSpriteTwistPP.text
					#instanceOrientPP: 	edRIBCode.text = ro_RIBit_Attributes.edInstanceOrientPP.text
				)
				destroyDialog ro_RIBit_params_edit
			)

			on bnOK pressed do (
				destroyDialog ro_RIBit_params_edit
			)
		) -- end ro_RIBit_params_edit rollout


		editText edColorPP "" 			width:1 height:1 visible:false pos:[0,0]
		editText edOpacityPP "" 		width:1 height:1 visible:false pos:[0,0]
		editText edSizePP "" 			width:1 height:1 visible:false pos:[0,0]
		editText edRIBBoxPP "" 			width:1 height:1 visible:false pos:[0,0]
		editText edSpriteTwistPP "" 	width:1 height:1 visible:false pos:[0,0]
		editText edInstanceOrientPP "" 	width:1 height:1 visible:false pos:[0,0]

		group "Particle Type " (
			radiobuttons rbType "" labels:#("Point        ", "Curve", "Sphere", "Blobby", "Sprite", "Instance") align:#left columns:2
		)

		group "Per-Particle Parameters " (
			checkbutton cbColor "Edit Color..." width:130
			checkbutton cbOpacity "Edit Opacity..." width:130
			checkbutton cbSize "Edit Size..." width:130
			checkbutton cbRIBBox "Edit RIB Box..." width:130
		)

		fn updateButtons n =
		(
			cbColor.state = n == #colorPP
			cbOpacity.state = n == #opacityPP
			cbSize.state = n == #sizePP
			cbRIBBox.state = n == #ribBoxPP
			try (this.ro_RIBit_SpriteAttr.cbSpriteTwist.state = n == #spriteTwistPP)catch()
			try(this.ro_RIBit_InstanceAttr.cbInstanceOrientPP.state = n == #instanceOrientPP)catch()
		)

		fn createEditDialog modeName title =
		(

			try (destroyDialog ro_RIBit_params_edit) catch()
			editBoxMode = modeName
			updateButtons modeName
			createDialog ro_RIBit_params_edit width:410
			ro_RIBit_params_edit.title = "Edit Per-Particle Parameters: " + title
		)

		-- Event Handlers
		------------------
		on cbColor changed state do (
			if state then (
				createEditDialog #colorPP "Color"
			) else (
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = #none
			)
		)
		on cbOpacity changed state do (
			if state then (

				createEditDialog #opacityPP "Opacity"
			) else (
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = #none
			)
		)
		on cbSize changed state do (
			if state then (

				createEditDialog #sizePP "Size"
			) else (
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = #none
			)
		)
		on cbRIBBox changed state do (
			if state then (
				createEditDialog #ribBoxPP "RIB Box"
			) else (
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = #none
			)
		)
		on cbSpriteTwist changed state do (
			if state then (
				createEditDialog #spriteTwistPP "Sprite Twist"

			) else (
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = #none
			)
		)

		on ro_RIBit_Attributes close do (
			try (destroyDialog ro_RIBit_params_edit) catch()
		)
	) -- end ro_RIBit_Attributes rollout



	rollout ro_RIBit_SpriteAttr "Sprite Attributes" rolledup:true
	(
		checkbutton cbSpriteTwist "Edit Sprite Twist..." width:130

		on cbSpriteTwist changed state do (
			if state then (
				ro_RIBit_Attributes.createEditDialog #spriteTwistPP "Sprite Twist"
			) else (
				try (destroyDialog ro_RIBit_Attributes.ro_RIBit_params_edit) catch()
				ro_RIBit_Attributes.editBoxMode = #none
			)
		)
	) -- end of ro_RIBit_SpriteAttr rollout





	parameters RIBit_InstanceAttr rollout:ro_RIBit_InstanceAttr
	(
		instanceObjects type:#nodeTab tabSize:0 tabSizeVariable:true
		instanceMode type:#integer ui:rbInstanceMode default:1 animatable:false
		instanceOrientMode type:#integer ui:rbInstanceOrientMode default:1 animatable:false
	)

	rollout ro_RIBit_InstanceAttr "Instance Attributes" rolledup:true
	(
		local objFilterFn
		local objList = #()

		group "Instances: " (
			listbox lbInstances ""
			pickbutton pbInstAdd "Add" width:45 height:16 align:#left offset:[0,-3] tooltip:"Add an object to the list." across:2 filter:objFilterFn
			button bnInstDel "Remove" width:45 height:16 align:#right pos:(pbInstAdd.pos + [50,0]) tooltip:"Remove an object to the list." enabled:(lbInstances.selection > 0)
			radioButtons rbInstanceMode "Use instances:" labels:#("Randomly", "Ordered") columns:2
		)
		group "Orientation: " (
			radioButtons rbInstanceOrientMode "" labels:#("Object Rotation", "Random", "Camera Direction", "Expression")
			checkbutton cbInstanceOrientPP "Edit Instance Orientation..." width:140 enabled:((rbInstanceOrientMode.state == 4) or (rbInstanceOrientMode.state == 3))
		)

		fn objFilterFn obj = (isKindOf obj GeometryClass and (findItem objList obj) == 0)


		on lbInstances selected item do (
			bnInstDel.enabled = lbInstances.selection > 0
		)

		on pbInstAdd picked obj do (
			if isValidNode obj then (
				flashNodes #(obj)
				append objList obj
				this.instanceObjects = objList
				lbInstances.items = for o in objList collect o.name
				bnInstDel.enabled = lbInstances.selection > 0

			)
		)

		on bnInstDel pressed do (
			deleteItem objList lbInstances.selection
			this.instanceObjects = objList
			lbInstances.items = for o in objList collect o.name
			bnInstDel.enabled = lbInstances.selection > 0
		)

		on rbInstanceOrientMode changed state do (
			cbInstanceOrientPP.enabled = (state == 4) or (state == 3)
			case state of (
				3: cbInstanceOrientPP.text = "Edit Instance Twist..."
				4: cbInstanceOrientPP.text = "Edit Instance Orientation..."
			)
		)

		on cbInstanceOrientPP changed state do (
			if state then (
				ro_RIBit_Attributes.createEditDialog #instanceOrientPP "Instance Orientation"
			) else (
				try (destroyDialog ro_RIBit_Attributes.ro_RIBit_params_edit) catch()
				ro_RIBit_Attributes.editBoxMode = #none
			)
		)

		on ro_RIBit_InstanceAttr open do (
			objList = this.instanceObjects
			lbInstances.items = for o in objList collect o.name
			case rbInstanceOrientMode.state of (
				3: cbInstanceOrientPP.text = "Edit Instance Twist..."
				4: cbInstanceOrientPP.text = "Edit Instance Orientation..."
			)
			cbInstanceOrientPP.enabled = (rbInstanceOrientMode.state == 4) or (rbInstanceOrientMode.state == 3)
			bnInstDel.enabled = lbInstances.selection > 0
		)
	) -- end of ro_RIBit_InstanceAttr rollout

 ) -- end mo_RIBit_Geometry modifier







