--*********************************************************************************

--* This file is part of the RIBit Renderman(tm) exporter for max

--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes

--*********************************************************************************

plugin modifier mo_RIBit_Shaders
	name:"RIBit Rendering"
	category:"RIBit"
	classID:#(0x5511d948, 0x52866c3a)
	version:1
(

	parameters RIBit_Attributes rollout:ro_RIBit_Attributes
	(
		Color			type:#color ui:cpColor default:[125,125,125]
		Opacity 		type:#color ui:cpOpacity default:[255,255,255]
		Surface  		type:#string ui:edSurface default:"matte"
		SurfaceParams	type:#string ui:edEditSurfaceParams default:""
		Displacement  	type:#string ui:edDisplacement default:""
		DisplacementParams	type:#string ui:edEditDisplacementParams default:""
		Atmosphere	 		type:#string ui:edAtmosphere default:""
		AtmosphereParams	type:#string ui:edEditAtmosphereParams default:""
		ShadingInterpolation type:#string default:"smooth"
		matte				 type:#boolean default:false ui:cbMatte

--		on Color set val do
--			if $ != undefined then
--				$.wirecolor = val
	)


	rollout ro_RIBit_Attributes "RIBit Rendering Attributes"
	(
		local editBoxMode = 0

-- ******************* 	ro_RIBit_paramsExp_edit start ***********************--
		rollout ro_RIBit_paramsExp_edit "Edit Shader Parameters"
		(
			local editBoxMode = 0

			editText edRIBCode "" width:400 height:200 pos:[5,5] text:""
			button bnClear "Clear" width:60 height:16 offset:[-150,0]
			button bnCancel "Cancel" width:60 height:16 pos:(bnClear.pos + [230,0])
			button bnOK "OK" width:60 height:16 pos:(bnCancel.pos + [75,0])

			on bnClear pressed do (
				edRIBCode.text = ""
			)

			on ro_RIBit_paramsExp_edit open do (
				editBoxMode = ro_RIBit_Attributes.editBoxMode
				case editBoxMode of (
					1: edRIBCode.text = ro_RIBit_Attributes.edEditSurfaceParams.text
					2: edRIBCode.text = ro_RIBit_Attributes.edEditDisplacementParams.text
					3: edRIBCode.text = ro_RIBit_Attributes.edEditAtmosphereParams.text
				)
			)

			on ro_RIBit_paramsExp_edit close do (
				local lines = filterString edRIBCode.text "\n\r"
				local str = ""
				if lines.count > 0 then (
					str = lines[1]
					for i = 2 to lines.count do
						str += "\n" + lines[i]
				)
				case editBoxMode of (
					1: ro_RIBit_Attributes.edEditSurfaceParams.text = str
					2: ro_RIBit_Attributes.edEditDisplacementParams.text = str
					3: ro_RIBit_Attributes.edEditAtmosphereParams.text = str
				)
				ro_RIBit_Attributes.editBoxMode = 0
				ro_RIBit_Attributes.updateButtons 0
			)

			on bnCancel pressed do (
				case editBoxMode of (
					1: edRIBCode.text = ro_RIBit_Attributes.edEditSurfaceParams.text
					2: edRIBCode.text = ro_RIBit_Attributes.edEditDisplacementParams.text
					3: edRIBCode.text = ro_RIBit_Attributes.edEditAtmosphereParams.text
				)
				destroyDialog ro_RIBit_paramsExp_edit
			)

			on bnOK pressed do (
				destroyDialog ro_RIBit_paramsExp_edit
			)
		) -- end ro_RIBit_paramsExp_edit rollout
-- ******************* 	ro_RIBit_paramsExp_edit end ***********************--



-- *******************  ro_RIBit_params_edit start *************************--
		rollout ro_RIBit_params_edit "Edit Shader Parameters"
		(
			-- Local Varable Declerations
			--------------------------------
			local shaderInfo
			local roParameters
			local shaderName
			local editBoxMode = 0
			local currentValues = ""


			-- User Interface
			-------------------------------
			subRollout sroParameters height:500 width:300 pos:[5,5]

			button bnCancel "Cancel" width:50 height:18 offset:[-10,0]
			button bnOK "OK" width:50 height:18 pos:(bnCancel.pos + [65,0])
			button bnApply "Apply" width:50 height:18 pos:(bnOK.pos + [65,0])


			-- Functions
			---------------------------
			fn getShaderInfo =
			(
				local shaderDir = if RIBit_Settings != undefined then RIBit_Settings.ShaderDir else sysInfo.tempDir
				local shaderInfo
				for p in RIBit_ShaderInfoParsers do (
					shaderInfo = (p.getInfo (shaderDir + shaderName))
					if shaderInfo != undefined and shaderInfo.name != undefined then exit
				)
				shaderInfo
			)

			fn generateRollout =
			(
				local rc = rolloutCreator "roParameters" (shaderInfo.name as string + " Parameters")
				rc.begin()
				rc.addLocal "shaderInfo"
				local contType, contName, contParams = "", contEvent, eventParams = "val"
				for i = 1 to shaderInfo.params.count do (
					local p = shaderInfo.params[i]
					contParmas = ""
					case p.type of (
						"string": 	(contType = #edittext; contName = ("ed" + p.name) as name; if p.defaultValue != undefined then contParmas = "text:\"" + p.defaultValue as string + "\""; contEvent = #entered)
						"float": 	(contType = #spinner; contName = ("sp" + p.name) as name; if p.defaultValue != undefined then contParmas = "range:[-1e7, 1e7, " + p.defaultValue as string + "]"; contEvent = #changed)
						"color": 	(contType = #colorpicker; contName = ("cp" + p.name) as name; if p.defaultValue != undefined then contParmas = "color:("+ p.defaultValue as string +")"; contEvent = #changed)
						"vector": 	(contType = #edittext; contName = ("ed" + p.name) as name; if p.defaultValue != undefined then contParmas = "text:\"" + p.defaultValue as string + "\""; contEvent = #entered)
						"point": 	(contType = #edittext; contName = ("ed" + p.name) as name; if p.defaultValue != undefined then contParmas = "text:\"" + p.defaultValue as string + "\""; contEvent = #entered)
						"normal": 	(contType = #edittext; contName = ("ed" + p.name) as name; if p.defaultValue != undefined then contParmas = "text:\"" + p.defaultValue as string + "\""; contEvent = #entered)
						default: 	(contType = #edittext; contName = ("ed" + p.name) as name; if p.defaultValue != undefined then contParmas = "text:\"" + p.defaultValue as string + "\""; contEvent = #entered)
					)
					rc.addControl contType contName (p.name + " (" + p.type + "): ") paramStr:contParmas
					local codeStr
					case p.type of (
						"vector": 	codeStr = "val = RIBit_Functions.removeSpaces val; if val[1] != \"[\" then val = \"[\" + val; if val[val.count] != \"]\" then val += \"]\"; " + contName + ".text = val; try(shaderInfo.params[" + i as string + "].value = execute val) catch()"
						"point": 	codeStr = "val = RIBit_Functions.removeSpaces val; if val[1] != \"[\" then val = \"[\" + val; if val[val.count] != \"]\" then val += \"]\"; " + contName + ".text = val; try(shaderInfo.params[" + i as string + "].value = execute val) catch()"
						"normal": 	codeStr = "val = RIBit_Functions.removeSpaces val; if val[1] != \"[\" then val = \"[\" + val; if val[val.count] != \"]\" then val += \"]\"; " + contName + ".text = val; try(shaderInfo.params[" + i as string + "].value = execute val) catch()"
						default: 	codeStr = "shaderInfo.params[" + i as string + "].value = val"
					)
					rc.addHandler contName contEvent paramStr:eventParams codeStr:codeStr
				)
				rc.end()
			)

			fn updateShaderInfoFromUI =
			(
				for i = 1 to roParameters.controls.count do (
					local val
					local c = roParameters.controls[i]
					case (classOf c) of (
						SpinnerControl: val = c.value
						EditTextControl: val = try(execute c.text)catch(c.text)
						ColorPickerControl:	val = c.color
					)
					shaderInfo.params[i].value = val
				)
			)

			fn getCurrentValues =
			(
				global RIBit_Functions
				local op = s_RIBit_Option ""
				op.paramsFromText currentValues
				for p in op.params where (p.name != undefined) do (
					local n = filterString p.name " "
					p.name = n[n.count] as name
				)
				local names = for p in op.params collect p.name
				for c in roParameters.controls do (
					local i = findItem names ((subString c.name 3 (c.name.count - 2)) as name)
					if i > 0 then (
						try(
							case (classOf c) of (
								SpinnerControl: c.value = op.params[i].value
								EditTextControl: c.text = op.params[i].value as string
								ColorPickerControl:	(col = execute ("color " + op.params[i].value + " 1"); c.color = col * 255.)
							)
						)catch()
					)
				)
			)



			fn init =
			(
				editBoxMode = ro_RIBit_Attributes.editBoxMode
				case editBoxMode of
				(
					1: (shaderName = ro_RIBit_Attributes.edSurface.text; currentValues = ro_RIBit_Attributes.edEditSurfaceParams.text)
					2: (shaderName = ro_RIBit_Attributes.edDisplacement.text; currentValues = ro_RIBit_Attributes.edEditDisplacementParams.text)
					3: (shaderName = ro_RIBit_Attributes.edAtmosphere.text; currentValues = ro_RIBit_Attributes.edEditAtmosphereParams.text)
				)
				shaderInfo = getShaderInfo()
				if shaderInfo == undefined then return()
				roParameters = generateRollout()
				if isKindOf roParameters RolloutClass then
					addSubRollout sroParameters roParameters
				roParameters.shaderInfo = shaderInfo
				getCurrentValues()
				updateShaderInfoFromUI()
			)

			fn shaderParamsToStr =
			(
				shaderInfo = roParameters.shaderInfo
				if shaderInfo != undefined then (
					case editBoxMode of
					(
						1: ro_RIBit_Attributes.edEditSurfaceParams.text = shaderInfo.asString()
						2: ro_RIBit_Attributes.edEditDisplacementParams.text = shaderInfo.asString()
						3: ro_RIBit_Attributes.edEditAtmosphereParams.text = shaderInfo.asString()
					)
				)
			)

			fn done =
			(
				shaderParamsToStr()
				ro_RIBit_Attributes.editBoxMode = 0
				ro_RIBit_Attributes.updateButtons 0
			)
			-- Event Handlers
			---------------------
			on bnCancel pressed do (
				shaderInfo = roParameters.shaderInfo = undefined
				destroyDialog ro_RIBit_params_edit
			)
			on bnOK pressed do (
				destroyDialog ro_RIBit_params_edit
			)
			on bnApply pressed do (
				shaderParamsToStr()
			)

			on ro_RIBit_params_edit open do init()
			on ro_RIBit_params_edit close do done()

		) -- end of ro_RIBit_params_edit rollout

-- *******************  ro_RIBit_params_edit end *************************--


		editText edEditSurfaceParams "" width:1 height:1 visible:false pos:[0,0]
		editText edEditDisplacementParams "" width:1 height:1 visible:false pos:[0,0]
		editText edEditAtmosphereParams "" width:1 height:1 visible:false pos:[0,0]
		group "Colors " (
			colorpicker cpColor "Color        " align:#right modal:false title:"Object Color"
			colorpicker cpOpacity "Opacity       " align:#right modal:false title:"Object Opacity"
		)
		group "Shaders " (
			edittext edSurface "Surface" align:#right fieldWidth:75 across:3 offset:[65,0]
			checkbutton cbEditSurfaceParams "P" width:14 height:16 tooltip:"Edit shader parameters..." align:#right offset:[36,0]
			checkbutton cbEditSurfaceParamsExp "E" width:14 height:16 tooltip:"Edit shader parameters with expressions..." align:#right offset:[7,0]
			edittext edDisplacement "Displ" align:#right fieldWidth:75 across:3 offset:[65,0]
			checkbutton cbEditDisplacementParams "P" width:14 height:16 tooltip:"Edit shader parameters..." align:#right offset:[36,0]
			checkbutton cbEditDisplacementParamsExp "E" width:14 height:16 tooltip:"Edit shader parameters with expressions..." align:#right offset:[7,0]
			edittext edAtmosphere "Atmos" align:#right fieldWidth:75 across:3 offset:[65,0]
			checkbutton cbEditAtmosphereParams "P" width:14 height:16 tooltip:"Edit shader parameters..." align:#right offset:[36,0]
			checkbutton cbEditAtmosphereParamsExp "E" width:14 height:16 tooltip:"Edit shader parameters with expressions..." align:#right offset:[7,0]
		)
		dropDownList dlShadingInterpolation "Shad Interp" align:#left items:#("smooth","constant")
		checkbox cbMatte "Matte"


		fn updateButtons n =
		(
			cbEditSurfaceParams.state = n == 1
			cbEditDisplacementParams.state = n == 2
			cbEditAtmosphereParams.state = n == 3
			cbEditSurfaceParamsExp.state = n == 4
			cbEditDisplacementParamsExp.state = n == 5
			cbEditAtmosphereParamsExp.state = n == 6
		)


		-- Event Handlers
		------------------
		on cpColor changed val do (
			if $ != undefined then
				$.wirecolor = val
		)
		
		on cbEditSurfaceParams changed state do (
			if edSurface != "" then (
				if state then (
					try (destroyDialog ro_RIBit_paramsExp_edit) catch()
					try (destroyDialog ro_RIBit_params_edit) catch()
					editBoxMode = 1
					updateButtons 1
					createDialog ro_RIBit_params_edit width:310
				) else (
					try (destroyDialog ro_RIBit_params_edit) catch()
					editBoxMode = 0
				)
			)
		)

		on cbEditSurfaceParamsExp changed state do (
			if state then (
				try (destroyDialog ro_RIBit_paramsExp_edit) catch()
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = 1
				updateButtons 4
				createDialog ro_RIBit_paramsExp_edit width:410
				ro_RIBit_paramsExp_edit.title = "Edit Shader Parameters: Surface"
			) else (
				try (destroyDialog ro_RIBit_paramsExp_edit) catch()
				editBoxMode = 0
			)
		)

		on cbEditDisplacementParamsExp changed state do (
			if state then (
				try (destroyDialog ro_RIBit_paramsExp_edit) catch()
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = 2
				updateButtons 5
				createDialog ro_RIBit_paramsExp_edit width:410
				ro_RIBit_paramsExp_edit.title = "Edit Shader Parameters: Displacement"
			) else (
				try (destroyDialog ro_RIBit_paramsExp_edit) catch()
				editBoxMode = 0
			)
		)
		on cbEditAtmosphereParamsExp changed state do (
			if state then (
				try (destroyDialog ro_RIBit_paramsExp_edit) catch()
				try (destroyDialog ro_RIBit_params_edit) catch()
				editBoxMode = 3
				updateButtons 6
				createDialog ro_RIBit_paramsExp_edit width:410
				ro_RIBit_paramsExp_edit.title = "Edit Shader Parameters: Atmosphere"
			) else (
				try (destroyDialog ro_RIBit_paramsExp_edit) catch()
				editBoxMode = 0
			)
		)

		on dlShadingInterpolation selected val do (
			ShadingInterpolation = dlShadingInterpolation.selected
		)

		on ro_RIBit_Attributes open do (
			dlShadingInterpolation.selection = case ShadingInterpolation of ("smooth":1;"constant":2;)
		)
		on ro_RIBit_Attributes close do (
			try (destroyDialog ro_RIBit_paramsExp_edit) catch()
			try (destroyDialog ro_RIBit_params_edit) catch()
		)

	) -- end ro_RIBit_Attributes rollout

) -- end mo_RIBit_Geometry modifier






