-- the global RIBit functions
global RIBit_Functions = s_RIBit_Functions()

-- the gloabl RIBit settings
global RIBit_Settings = s_RIBit_Settings version:"0.3.1"



-- ShaderInfo parsers
global RIBit_ShaderInfoParsers = #()

-- 3Delight
append RIBit_ShaderInfoParsers (
	s_RIBit_ShaderInfoParser getInfoCommand:"shaderinfo.exe" shaderExt:".sdl" \
		parseInfoFn:(
			fn parseInfoFn &f &shaderInfo =
			(
				readLine f
				if not eof f then (
					local l = filterString (readLine f) "\" "
					shaderInfo.name = l[2]
					shaderInfo.type = l[1]
				)
				while not eof f do (
					local param = s_RIBit_ShaderInfoParam()
					local l = filterString (readLine f) "\""
					param.name = l[2]
					l = filterString l[4] " "
					param.class = l[1]
					if param.class  == "output" then (
						param.class = l[2]
						param.type = l[3]
					) else
						param.type = l[2]
					l = readLine f
					local n = ((findString l "Default value: ") + 15)
					local val = subString l n (l.count - n + 1)
					case param.type of (
						"string": 	(val = (filterString val "\"")[1])
						"float": 	(val = val as float)
						"color": 	(val = filterString val " []"; val = color (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float) 1.0; val *= 255.)
						"vector": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
						"point": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
						"normal": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
					)
					param.defaultValue = val
					append shaderInfo.params param
				)

			)
		)
)

-- pixie
append RIBit_ShaderInfoParsers (
	s_RIBit_ShaderInfoParser getInfoCommand:"sdrinfo.exe" shaderExt:".sdr" \
		parseInfoFn:(
			fn parseInfoFn &f &shaderInfo =
			(
				if not eof f then (
					local l = filterString (readLine f) "\" "
					shaderInfo.name = l[2]
					shaderInfo.type = l[1]
				)
				while not eof f do (
					local param = s_RIBit_ShaderInfoParam()
					local l = filterString (readLine f) "\""
					param.name = l[2]
					l = filterString l[4] " "
					param.class = l[1]
					param.type = l[2]
					l = readLine f
					local n = ((findString l "Default value: ") + 15)
					local val = subString l n (l.count - n)
					case param.type of (
						"string": 	(val = (filterString val "\"")[1])
						"float": 	(val = val as float)
						"color": 	(val = filterString val " []"; val = color (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float) 1.0; val *= 255.)
						"vector": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
						"point": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
						"normal": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
					)

					param.defaultValue = val
					append shaderInfo.params param
				)
				local reverseArr = #()
				for i = shaderInfo.params.count to 1 by -1 do
					append reverseArr shaderInfo.params[i]
				shaderInfo.params = reverseArr
			)
		)
)

-- aqsis
append RIBit_ShaderInfoParsers (
	s_RIBit_ShaderInfoParser getInfoCommand:"aqsltell.exe" shaderExt:".slx" \
		parseInfoFn:(
			fn parseInfoFn &f &shaderInfo =
			(
				if not eof f then (
					local l = filterString (readLine f) "\". "
					shaderInfo.name = l[2]
					shaderInfo.type = l[1]
				)
				while not eof f do (
					local param = s_RIBit_ShaderInfoParam()
					local l = filterString (readLine f) "\""
					param.name = l[2]
					l = filterString l[4] " "
					param.class = l[2]
					if param.class  == "output" then (
						param.class = l[3]
						param.type = l[4]
					) else
						param.type = l[3]
					l = readLine f
					local n = ((findString l "Default value: ") + 15)
					local val = subString l n (l.count - n + 1)
					case param.type of (
						"string": 	(val = (filterString val "\"")[1])
						"float": 	(val = val as float)
						"color": 	(val = filterString val " []"; val = color (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float) 1.0; val *= 255.)
						"vector": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
						"point": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
						"normal": 	(val = filterString val " []"; val = point3 (val[val.count-2] as float) (val[val.count-1] as float) (val[val.count] as float))
					)
					param.defaultValue = val
					append shaderInfo.params param
				)
			)
		)
)

