/*************************************************
 * MAX_shadowspot.sl
 * Writtne by Ofer Zelichover 12/2004
 * Based on the Aqsis shader shadowspot.sl code
 *************************************************/

light MAX_shadowspot(
	float intensity = 1;
	color lightcolor = 1;
	point from = point "shader" (0, 0, 0);
	point to =   point "shader" (0, 0, 1);
	float coneangle = radians(30);
	float conedeltaangle = radians(5);
	float beamdistribution = 2;
	string shadowname = "";
	float samples = 16;
	float width = 1;
	float blur = 0;
	float falloff = 0; //0: none; 1:Inverse Linear; 2:Inverse Squaew;
	float falloffstart = 0; //the distance from which to start the decay.
	float nearattnstart = -1; // use -1 to turn near-attenuation off
	float nearattnend = 0;
	float farattnstart = -1; // use -1 to turn far-attenuation off
	float farattnend = 0;
)
{
	float atten, cosangle;
	uniform point A = (to - from) / length(to - from);
	uniform float cosoutside = cos(coneangle);
	uniform float cosinside  = cos(coneangle - conedeltaangle);

	
	illuminate (from, A, coneangle) {
		cosangle = (L . A) / length(L);
		atten = pow(cosangle, beamdistribution);
			
		// Calculate the fallloff
		if (falloff != 0) {
			if (length(L) > falloffstart) {
				atten *= pow( (falloffstart / length(L)), falloff );
			}		}
		
			
		atten *= smoothstep(cosoutside, cosinside, cosangle);
		
		// Calculate near attenuation
		if (nearattnstart != -1) {
			atten *= smoothstep(nearattnstart, nearattnend, length(L));
		}
		// Calculate far attenuation
		if (farattnstart != -1) {
			atten *= 1 - smoothstep(farattnstart, farattnend, length(L));
		}
		
		Cl = atten * intensity * lightcolor;
		if (shadowname != "")
			Cl *= 1 - shadow(shadowname, Ps, "blur", blur, "width", width);
	}
}

