--*********************************************************************************


--* This file is part of the RIBit Renderman(tm) exporter for max

--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes

--*********************************************************************************


/*
Pixel Variance 		float 					Estimated variance of the computed pixel value from the true pixel value.

Sampling Rates 	2 floats 		2, 2 			Effective sampling rate in the horizontal and vertical directions.

Filter			 function	RiGaussianFilter 	Type of filtering and the width of
Filter Widths 		2 floats 		2, 2 			the filter in the horizontal and vertical directions.

Exposure
  gain 			float 		1.0 			Gain and gamma of the exposure
  gamma 		float 		1.0 			process.

Imager 			shader 		null			A procedure defining an image or pixel operator.

Color Quantizer 							Color and opacity quantization
  one 			integer 		255 			parameters.
  maximum 		integer 		0
  minimum 		integer 		255
  dither amplitude 	float 		0.5

Depth Quantizer 						Depth quantization parameters.
  one 			integer 		0
  maximum 		integer 		
  minimum 		integer 		
  dither amplitude 	float 		

Display Type 		token * 					Whether the display is a framebuffer or a file.
Display Name 		string * 					Name of the display device or file.
Display Mode 		token * 					Image output type.
*/


struct s_RIBit_Display (
	name, -- the filename or display name
	type, -- the type of the display (e.g. framebuffer, tiff, file, it, etc.)
	channels, -- the channels to render
	secondary = false,
	indent = "",
	fileHandle,

	fn write =
	(
		if fileHandle == unefined then return()
		local sec = if secondary then "+" else ""
		format "%Display \"%%\" \"%\" \"%\"\n" indent sec name type channels to:fileHandle
	)
) -- end of s_RIBit_Display struct
