--*********************************************************************************
--* This file is part of the RIBit Renderman(tm) exporter for max

--* By Ofer Zelichover
--* 2004/3/1 (c)
--* based in part on kcman by Rudy Cortes

--*********************************************************************************

struct s_RIBit_Transform (
	transform,
	concat = false,
	indent = "",
	fileHandle,

	fn localRotateX ang = (preRotateX transform ang),
	fn localRotateY ang = (preRotateY transform ang),
	fn localRotateZ ang = (preRotateZ transform ang),

	fn scale val =
	(
		if not (isKindOf val Point3) then return()
		transform *= scaleMatrix val
	),

	fn inversePOV =
	(
		transform = inverse transform
		transform = rotateY transform 180
		scale [-1,1,1]
	),

	fn transformBegin =
	(
		format "%TransformBegin\n" indent to:fileHandle
		indent += "\t"
	),

	fn transformEnd =
	(
		indent = subString indent 1 (indent.count - 1)
		format "%TransformEnd\n" indent to:fileHandle
	),

	fn write =
	(
		if fileHandle == undefined then return()
		local con = if concat then "Concat" else ""
		format "%%Transform [" indent con to:fileHandle
		format "% % % % " transform[1][1] transform[1][2] transform[1][3] 0 to:fileHandle
		format "% % % % " transform[2][1] transform[2][2] transform[2][3] 0 to:fileHandle
		format "% % % % " transform[3][1] transform[3][2] transform[3][3] 0 to:fileHandle
		format "% % % %]\n" transform[4][1] transform[4][2] transform[4][3] 1 to:fileHandle
	)
) -- end of s_RIBit_Transform struct

